﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
/*
* Nejjednodušší třída
*/
var BaseClass = (function () {
    function BaseClass() {
    }
    return BaseClass;
})();
var baseClassInstance = new BaseClass();

/*
* Třída 1
*/
var Animal = (function () {
    // Konstruktor
    function Animal(isMammal) {
        this.name = null;
        this.isMammal = isMammal;
    }
    Animal.prototype.setName = function (name) {
        this.name = name;
    };

    // Modifikátor public/private není poviný
    Animal.prototype.getName = function () {
        return this.name;
    };
    return Animal;
})();

var animalInstance = new Animal(true);

/*
* Třída 2 (neinicializované proměnné)
*/
var User = (function () {
    function User(age) {
        this.lastName = null;
        this.age = age;
    }
    User.prototype.getFirstName = function () {
        return this.firstName;
    };

    User.prototype.getLastName = function () {
        return this.lastName;
    };
    return User;
})();

var userInstance = new User(20);
userInstance.getFirstName();
userInstance.getLastName();

/*
* Dědičnost
*/
var BillGates = (function (_super) {
    __extends(BillGates, _super);
    function BillGates() {
        _super.call(this, 57);
        this.firstName = "Bill";
        this.lastName = "Gates";
    }
    BillGates.prototype.hasWife = function () {
        return true;
    };
    return BillGates;
})(User);

var billGatesInstance = new BillGates();
billGatesInstance.getFirstName();
billGatesInstance.getLastName();
billGatesInstance.hasWife();

/*
* Statické metody a atributy
* Pro vytvoření singletonu použijeme "hack", protože neexistuje privátní konstruktor
*/
var SingletonClass = (function () {
    function SingletonClass() {
        if (!SingletonClass.canCreateInstance) {
            throw new Error("'SingletonClass' is singleton! Please use 'GetInstance' method.");
        }
    }
    SingletonClass.GetInstance = function () {
        if (SingletonClass.instance === null) {
            SingletonClass.canCreateInstance = true;
            SingletonClass.instance = new SingletonClass();
            SingletonClass.canCreateInstance = false;
        }

        return SingletonClass.instance;
    };
    SingletonClass.instance = null;

    SingletonClass.canCreateInstance = false;
    return SingletonClass;
})();

var singletonClassInstance1 = SingletonClass.GetInstance();
var singletonClassInstance2 = SingletonClass.GetInstance();
var equals = singletonClassInstance1 === singletonClassInstance2 ? true : false;
var singletonClassInstance3 = new SingletonClass();
